//+------------------------------------------------------------------+
//|                                Multi_Lot_BOSS.mq4                |
//|                              Copyright  2007                    |   ULTIMA VARIANTA
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 , CM"
#property link      "                         "

extern double TakeProfit = 20;     // Valoarea la care ia profit
extern double Loturi = 1;          // Numarul de loturi tranzactionate - la primul nivel
extern double InitialStop = 0;     // Stop loss pentru toate tranzactiile 
extern double TrailingStop = 20;   // Numarul de pipsi la care se lanseaza o noua tranzactie , in sens invers
extern int MarjaPip = 3;

double myLot = 0;
int  OpenOrders = 0, cnt = 0;
int mode = 0, myOrderType = 0;
double sl = 0, tp = 0; 
double Lasttp = 0; 
double Lastsl = 0;
double BuyPrice = 0, SellPrice = 0;
double LastPrice = 0;
int nivel = 0;
int cmd,total,error;
double stop_loss;
bool   result;
color LastColor;
int i;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  { 

   OpenOrders = 0;
   for(cnt = 0; cnt < OrdersTotal(); cnt++)   
   {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	     if(OrderSymbol() == Symbol())
	  	       OpenOrders++;
   }       
//----
   if((OpenOrders == 0) || (OrdersTotal()==0)) 
   {
	  myOrderType = 0;
	  
     if(iMACD(NULL, 0, 5, 13, 1, PRICE_CLOSE, MODE_MAIN, 0) > iMACD(NULL, 0, 5, 13, 1, PRICE_CLOSE, MODE_MAIN, 1)) 
	          myOrderType = 2;     //---- BUY
	      
     if(iMACD(NULL, 0, 5, 13, 1, PRICE_CLOSE, MODE_MAIN, 0) < iMACD(NULL,0,5,13,1,PRICE_CLOSE, MODE_MAIN, 1)) 
	          myOrderType = 1;     //---- SELL

	  nivel=0; 
   }  
 Print("myOrderType = ",myOrderType);
 //----


//----     SELL     ----------------------------------------------------------------------------------
//----
     
   if(myOrderType == 1)            // SELL
     {
// =========== Inchide pozitiile ==============

       if(Ask <= Lasttp+MarjaPip*Point) 
       {
//xxxxxxxx Inchide toate ordinele care mai sunt deschise 

	            total=OrdersTotal();
	            
               for( i=total; i>=0; i--)
               {
                  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  {
                     OrderPrint();
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,LastColor);
                  }
               }
//xxxxxxxx Inchide toate ordinele care mai sunt deschise 
               nivel = 0;
       }


// ============================================
       
   if(  (Bid - LastPrice ) >= (TrailingStop*Point) || OrdersTotal() == 0) 
         {		
           SellPrice = Bid;
           LastPrice = SellPrice;
      
           if(TakeProfit == 0) 
               tp = 0; 
           else 
               tp = SellPrice - TakeProfit*Point; 
           Lasttp = tp;    
           
           if(InitialStop==0)  
               sl = 0; 
           else 
               sl = SellPrice + InitialStop*Point; 
           Lastsl = sl;
           
           if (nivel<2)
              myLot = Loturi;
           else
              myLot=myLot*2; 

           nivel=nivel+1;

           LastColor = Red;
           
		         OrderSend(Symbol(), OP_SELL, myLot, SellPrice, 0, sl, tp, NULL, 0, 0, Red);
		         
           return(0);
           
         }
     }   
//----     SELL     ----------------------------------------------------------------------------------
    

          
//----
     
   if(myOrderType == 2)            // BUY
     {
// =========== Inchide pozitiile ==============

       if(Bid >= Lasttp)
       {
//xxxxxxxx Inchide toate ordinele care mai sunt deschise 

	            total=OrdersTotal();
	            
               for( i=total; i>=0; i--)
               {
                  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  {
                     OrderPrint();
                     OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,LastColor);
                  }
               }
//xxxxxxxx Inchide toate ordinele care mai sunt deschise 
       
       }

// ============================================
       if((Ask - (LastPrice- TrailingStop*Point)<(5*Point)) || OpenOrders == 0) 
         {		
           BuyPrice = Ask;
           LastPrice = BuyPrice;
      
           if(TakeProfit == 0) 
               tp = 0; 
           else 
               tp = BuyPrice + TakeProfit*Point; 
           Lasttp = tp;    
           
           if(InitialStop==0)  
               sl = 0; 
           else 
               sl = BuyPrice - InitialStop*Point; 
           Lastsl = sl;
           
           if (nivel<2)
              myLot = Loturi;
           else
              myLot=myLot*2; 

           nivel=nivel+1;

           LastColor = MediumBlue;
           
		         OrderSend(Symbol(), OP_BUY, myLot, BuyPrice, 0, sl, tp, NULL, 0, 0, MediumBlue);
		         
           return(0);
           
         }
     }   
     else
     



//----     SELL     ----------------------------------------------------------------------------------




//----     SELL     ----------------------------------------------------------------------------------
    
    
//----    
//Comment(Symbol(),"  ",Bid,"  ",Ask,"  OpenOrders ",OpenOrders,"  MyOrderType  ",myOrderType,"  Nivel ",nivel,"   ",myLot,
//                 "\nConditie                 ",(Bid - (LastPrice- TrailingStop*Point))," LastPrice  ",LastPrice," Ticket ",OrderTicket());
//----
   return(0);
  }
//+------------------------------------------------------------------+

